// FILE: indriver.h              Copyright (c), Symmetric Research, 2003
//
// Include file shared between the PARxCH driver installation and removal
// utilities.


// Define the info structure

typedef struct DriverInfoTable {
        char *Name;
        int   PortAddr;
        int   PortIrq;
        } DRIVER_INFO_TABLE;


// Declare and initialize a global variable with the info data
// Other possibilities to be added could be 0x268, 0x26C, 0x27C
// Note: You must recompile indriver and rmdriver after adding new values.

DRIVER_INFO_TABLE DriverInfo[] = {
        "SrParXch378",   0x378,   7,
        "SrParXch278",   0x278,   5,
        "SrParXch3BC",   0x3BC,   7,
        NULL,            0x000,   0
        };

