VERSION 5.00
Begin VB.Form Demo 
   Caption         =   "PARxCH Demo"
   ClientHeight    =   4575
   ClientLeft      =   1125
   ClientTop       =   1410
   ClientWidth     =   5430
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4575
   ScaleWidth      =   5430
   Begin VB.TextBox FileNumTxt 
      Height          =   285
      Left            =   2160
      TabIndex        =   11
      TabStop         =   0   'False
      Text            =   "None"
      Top             =   3000
      Width           =   975
   End
   Begin VB.ListBox ModelNameLst 
      Height          =   645
      ItemData        =   "DEMO.frx":0000
      Left            =   2040
      List            =   "DEMO.frx":000D
      TabIndex        =   4
      Top             =   1800
      Width           =   1455
   End
   Begin VB.TextBox InstructTxt 
      Appearance      =   0  'Flat
      BackColor       =   &H00C0C0C0&
      Height          =   1095
      Left            =   240
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   0
      TabStop         =   0   'False
      Text            =   "DEMO.frx":0029
      Top             =   120
      Width           =   4935
   End
   Begin VB.Frame PortModeFra 
      Caption         =   "&Port Mode"
      Height          =   1815
      Left            =   3840
      TabIndex        =   5
      Top             =   1440
      Width           =   1335
      Begin VB.OptionButton PortModeOpt 
         Caption         =   "BPP"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   6
         Top             =   360
         Width           =   735
      End
      Begin VB.OptionButton PortModeOpt 
         Caption         =   "EPP"
         Height          =   255
         Index           =   1
         Left            =   120
         TabIndex        =   7
         Top             =   720
         Value           =   -1  'True
         Width           =   615
      End
      Begin VB.OptionButton PortModeOpt 
         Caption         =   "ECP/BPP"
         Height          =   255
         Index           =   2
         Left            =   120
         TabIndex        =   8
         Top             =   1080
         Width           =   1095
      End
      Begin VB.OptionButton PortModeOpt 
         Caption         =   "ECP/EPP"
         Height          =   255
         Index           =   3
         Left            =   120
         TabIndex        =   9
         Top             =   1440
         Width           =   1095
      End
   End
   Begin VB.ListBox DriverNameLst 
      Height          =   645
      ItemData        =   "DEMO.frx":0147
      Left            =   240
      List            =   "DEMO.frx":0154
      TabIndex        =   2
      Top             =   1800
      Width           =   1455
   End
   Begin VB.CommandButton RunBtn 
      Caption         =   "&Run"
      Height          =   615
      Left            =   600
      TabIndex        =   12
      Top             =   3720
      Width           =   1215
   End
   Begin VB.CommandButton StopBtn 
      Caption         =   "&Stop"
      Height          =   615
      Left            =   2040
      TabIndex        =   13
      Top             =   3720
      Width           =   1215
   End
   Begin VB.CommandButton ExitBtn 
      Caption         =   "E&xit"
      Height          =   615
      Left            =   3480
      TabIndex        =   14
      Top             =   3720
      Width           =   1215
   End
   Begin VB.Label FileNumLbl 
      Caption         =   "Wrote File Number"
      Height          =   255
      Left            =   600
      TabIndex        =   10
      Top             =   3000
      Width           =   1455
   End
   Begin VB.Label ModelNameLbl 
      Caption         =   "Xch &Model"
      Height          =   255
      Left            =   2160
      TabIndex        =   3
      Top             =   1440
      Width           =   1335
   End
   Begin VB.Label DriverNameLbl 
      Caption         =   "&Driver Name"
      Height          =   255
      Left            =   360
      TabIndex        =   1
      Top             =   1440
      Width           =   1335
   End
End
Attribute VB_Name = "Demo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()

        Dim Dummy           As Long
        Dim MsgResponse     As Integer
        Dim MsgWords        As String


        ' If the PARxCH library is compiled with GPS_AVAILABLE, the
        ' PARxCH DLL contains a call to ParGpsGetKernelArea which is
        ' located in the PARGPS DLL.  But VB does not appear to
        ' recognize this fact.  So we put a dummy call here to force
        ' VB into loading the function.  If this is not included, VB
        ' claims it can't find the PARxCH DLL.  Of course, your
        ' project must also include the pargps/vbasic/pargps.bas
        ' module file so this function is defined.
        
#If GPS_AVAILABLE Then
        Dummy = ParGpsGetKernelArea(PARGPS_BAD_DEVHANDLE, Dummy)
#End If


        ' Set working directory to path of exe
        ' (does not work right for UNC paths given from Dos Prompt)

        On Error Resume Next
        ChDrive App.Path
        ChDir   App.Path


        ' Initialize some variables

        NL = Chr(13) & Chr(10)
        WorkingDir = App.Path
        Call ParXchInitErrorMsg


        ' Initialize driver name list

        DriverNameLst.Clear

        DriverNameLst.AddItem "SrParXch378"
        DriverNameLst.ItemData(DriverNameLst.NewIndex) = &H378

        DriverNameLst.AddItem "SrParXch278"
        DriverNameLst.ItemData(DriverNameLst.NewIndex) = &H278
        
        DriverNameLst.AddItem "SrParXch3BC"
        DriverNameLst.ItemData(DriverNameLst.NewIndex) = &H3BC
        
        DriverNameLst.Selected(0) = True

        

        ' Initialize Xch model name list

        ModelNameLst.Clear

        ModelNameLst.AddItem "DEFAULT"
        ModelNameLst.ItemData(ModelNameLst.NewIndex) = PARXCH_MODEL_UNKNOWN

        ModelNameLst.AddItem PAR1CH_MODELNAME
        ModelNameLst.ItemData(ModelNameLst.NewIndex) = PARXCH_MODEL_PAR1CH

        ModelNameLst.AddItem PAR4CH_MODELNAME
        ModelNameLst.ItemData(ModelNameLst.NewIndex) = PARXCH_MODEL_PAR4CH
        
        ModelNameLst.AddItem PAR8CH_MODELNAME
        ModelNameLst.ItemData(ModelNameLst.NewIndex) = PARXCH_MODEL_PAR8CH

        ModelNameLst.Selected(0) = True
        
        

        ' Set initial state

        DemoState = DEMO_STOPPED
        FileNumLbl.Enabled = False
        FileNumTxt.Enabled = False

End Sub


Private Sub RunBtn_Click()

        Dim Ready           As Long
        Dim Nread           As Long
        Dim Init            As Long
        Dim ADS1210_CrValue As Long
        Dim Error           As Long
        Dim NextPt          As Long
        Dim Nremain         As Long
        Dim DataFormat      As Long
        Dim PointsPerChan   As Long
        Dim SampleRate      As Double
        Dim GainLog         As Double
        Dim BufferFull      As Integer
        Dim MsgResponse     As Integer
        Dim MsgWords        As String
        

        ' Get driver, model and port information from controls

        DriverName = DriverNameLst.Text


        XchModel = ModelNameLst.ItemData(ModelNameLst.ListIndex)
        If (XchModel = PARXCH_MODEL_UNKNOWN) Then
               XchModel = ParXchGetDefaultModel(DriverName)
        End If
        
        If (XchModel = PARXCH_MODEL_PAR1CH) Then
               ParXchAnalogChannels = PAR1CH_ANALOG_CHANNELS
               ModelName = PAR1CH_MODELNAME
        ElseIf (XchModel = PARXCH_MODEL_PAR4CH) Then
               ParXchAnalogChannels = PAR4CH_ANALOG_CHANNELS
               ModelName = PAR4CH_MODELNAME
        ElseIf (XchModel = PARXCH_MODEL_PAR8CH) Then
               ParXchAnalogChannels = PAR8CH_ANALOG_CHANNELS
               ModelName = PAR8CH_MODELNAME
        Else
               MsgWords = "Unknown Xch Model # " + Str(XchModel) + NL
               MsgResponse = MsgBox(MsgWords, vbOKOnly, "ERR_DEVID")
               Unload Me
               Exit Sub
        End If

        

        If (PortModeOpt(0).Value = True) Then
                PortMode = PARXCH_PORT_MODE_BPP
        ElseIf (PortModeOpt(1).Value = True) Then
                PortMode = PARXCH_PORT_MODE_EPP
        ElseIf (PortModeOpt(2).Value = True) Then
                PortMode = PARXCH_PORT_MODE_ECP_BPP
        ElseIf (PortModeOpt(3).Value = True) Then
                PortMode = PARXCH_PORT_MODE_ECP_EPP
        Else
                PortMode = PARXCH_PORT_MODE_EPP
        End If



        ' Turn driver/model/port controls off and fifo/file controls on

        DriverNameLbl.Enabled = False
        DriverNameLst.Enabled = False
        ModelNameLbl.Enabled = False
        ModelNameLst.Enabled = False
        PortModeFra.Enabled = False
        PortModeOpt(0).Enabled = False
        PortModeOpt(1).Enabled = False
        PortModeOpt(2).Enabled = False
        PortModeOpt(3).Enabled = False

        FileNumLbl.Enabled = True
        FileNumTxt.Enabled = True

        FileNumTxt.Text = "None"
        FileNumTxt.Refresh

        FileNum = 0


        ' Open and initialize PARxCH

        DataFormat = PARXCH_DF_SIGNED
        GainLog    = PARXCH_GAIN_1
        SampleRate = 100#           ' to match PARXCH_DECIMATION_100Hz_T16
        
        ParXchHandle = ParXchFullOpen(DriverName, XchModel, PortMode, _
                DataFormat, GainLog, PARXCH_TURBO_16, _
                PARXCH_DECIMATION_100Hz_T16, PARXCH_EXTRADECIMATION_MIN, _
                PARXCH_UNUSED, ADS1210_CrValue, Error)

        If (ParXchHandle = PARXCH_BAD_DEVHANDLE) Then
            MsgWords = "Could not initialize " + ModelName + " board" + NL
            MsgWords = MsgWords + "Error is " + Str(Error) + NL
            MsgWords = MsgWords + PARXCH_ERROR_MSG(Error)
            MsgResponse = MsgBox(MsgWords, vbOKOnly, "ERR_INIT")
            Unload Me
            Exit Sub
        End If



        ' Dimension data array to hold buffer size

        PointsPerChan = 128  ' This is an arbitrary, but reasonable number
        Nvalues = PointsPerChan * ParXchAnalogChannels

        ReDim DataArray(0 To Nvalues - 1)



        ' Write out header file

        Call Write_Header( ParXchAnalogChannels, _
                           PointsPerChan, _
                           DataFormat, _
                           SampleRate, _
                           GainLog )



        ' Begin acquisition

        DemoState = DEMO_RUNNING
        Call ParXchStart(ParXchHandle)

        Do While (DemoState = DEMO_RUNNING)

                BufferFull = 0
                NextPt = 0
                Nremain = Nvalues

                Do While (BufferFull = 0)

                        ' Read any ready data

                        Nread = ParXchReadData(ParXchHandle, _
                                               DataArray(NextPt), _
                                               Nremain, _
                                               Error)

                        Nremain = Nremain - Nread
                        NextPt = NextPt + Nread


                        ' Check for a fatal error

                        If (Error <> PARXCH_ERROR_NONE) Then
                                MsgWords = "Read Data Error: "
                                MsgWords = MsgWords + PARXCH_ERROR_MSG(Error)
                                MsgResponse = MsgBox(MsgWords, vbOKOnly, _
                                                                   "ERR_READ")
                                Call ExitBtn_Click
                                Exit Sub
                        End If


                        ' Check for buffer full

                        If (Nremain <= 0) Then
                                BufferFull = 1
                        End If


                        ' Check to see if stop button has been pressed
                        DoEvents
                        If (DemoState <> DEMO_RUNNING) Then
                                BufferFull = 1
                        End If

                Loop  ' on !BufferFull


                ' Write data to a file and disply file number

                Call Write_Data
                FileNumTxt.Text = Str(FileNum - 1)
                FileNumTxt.Refresh

                ' Check to see if stop button has been pressed
                DoEvents

        Loop  ' on DEMO_RUNNING

End Sub

Private Sub StopBtn_Click()

        ' Stop and close PARxCH

        Call ParXchStop(ParXchHandle)
        DemoState = DEMO_STOPPED

        Call ParXchClose(ParXchHandle)


        ' Turn driver/model/port controls on and fifo/file controls off

        DriverNameLbl.Enabled = True
        DriverNameLst.Enabled = True
        ModelNameLbl.Enabled = True
        ModelNameLst.Enabled = True
        PortModeFra.Enabled = True
        PortModeOpt(0).Enabled = True
        PortModeOpt(1).Enabled = True
        PortModeOpt(2).Enabled = True
        PortModeOpt(3).Enabled = True

        FileNumLbl.Enabled = False
        FileNumTxt.Enabled = False
        
End Sub

Private Sub ExitBtn_Click()

        ' Be sure to stop before exiting

        If (DemoState = DEMO_RUNNING) Then
                Call StopBtn_Click
        End If


        ' Do exit

        Unload Me
End Sub
