@echo off

echo   Ŀ
echo     WinNT4.0 PARxCH/PARGPS INSTALL   WinNT4.0 PARxCH/PARGPS INSTALL  
echo                                                                      
echo                  TO USE THIS INSTALLATION BATCH FILE:                
echo                   MAKE THIS DISK YOUR CURRENT DRIVE                  
echo                                                                      
echo            To install the software in the standard directories,      
echo      execute install.bat with NO command line parameters to create   
echo               and unpack C:\SR\PARXCH and C:\SR\PARGPS               
echo                                                                      
echo            To install the software in nonstandard directories,       
echo         execute install.bat with the target DRIVE AND DIRECTORY      
echo            specified on the command line, eg: install e:\srnt        
echo                                                                      
echo       This part of the installation will only create directories     
echo         and unpack the files.  No changes will be made to your       
echo                         registry or drivers.                         
echo                                                                      
echo             Ctrl+C will kill the installation at any time            
echo   


rem Set target directory
rem

if "%1" == "" goto stdtarget
              goto usertarget

:stdtarget
set target_dir=C:\SR
goto checktarget

:usertarget
set target_dir=%1
goto checktarget


rem Verify target directory
rem

:checktarget

echo.
echo Ready to install in directories %target_dir%\PARXCH and %target_dir%\PARGPS
pause

if exist %target_dir%\PARXCH\*.*   goto error_xch
if exist %target_dir%\PARGPS\*.*   goto error_gps



rem Do the install
rem

pkunzip -d PARXCH.ZIP %target_dir%
pkunzip -d PARGPS.ZIP %target_dir%

echo   Ŀ
echo         WinNT4.0 PARxCH/PARGPS basic installation is finished.       
echo                                                                      
echo     Next, as Administrator, install the kernel mode device drivers   
echo               for the PARxCH and PARGPS using indriver.exe.          
echo                                                                      
echo          First install the PARxCH driver:                            
echo              cd \sr\parxch\driver                                    
echo              indriver SrParXch378 PAR4CH                             
echo                                                                      
echo          Then install the PARGPS driver:                             
echo              cd \sr\pargps\driver                                    
echo              indriver SrParGps                                       
echo                                                                      
echo       See readme.txt in the respective .\driver directories for      
echo                         more information.                            
echo                                                                      
echo   

pause
goto end



:error_xch
echo.
echo ERROR: Target directory %target_dir%\PARXCH already exists
echo        Please rename or delete it before installing.
echo.
if exist %target_dir%\PARGPS\*.*   goto error_gps
goto end


:error_gps
echo.
echo ERROR: Target directory %target_dir%\PARGPS already exists
echo        Please rename or delete it before installing.
echo.
goto end


:end
set target_dir=

@echo on
