@echo off

rem FILE: makeall.bat           Copyright (c), Symmetric Research, 2003
rem
rem This batch file does a complete build of the SR PARGPS software.  See
rem the makeall.rpt report file when done for any errors.  Note that you 
rem must have the Microsoft Visual C++ 6.0 compiler installed for this
rem file to run correctly.
rem
rem

echo Building SR PARGPS NT software with PARxCH A/D ... see makeall.rpt for errors ...
echo.

echo SR PARGPS NT build report with PARxCH A/D ... > MAKEALL.RPT


cd driver
nmake /a                                        >> ..\MAKEALL.RPT
if errorlevel 1 goto error

cd ..\lib
nmake /a                                        >> ..\MAKEALL.RPT
if errorlevel 1 goto error

cd ..\diags
nmake /a                                        >> ..\MAKEALL.RPT
if errorlevel 1 goto error

cd ..\currtime
nmake /a                                        >> ..\MAKEALL.RPT
if errorlevel 1 goto error

cd ..\utils
nmake /a                                        >> ..\MAKEALL.RPT
if errorlevel 1 goto error

cd ..\vbasic
nmake /a                                        >> ..\MAKEALL.RPT
if errorlevel 1 goto error

goto return







rem Return:
rem
rem

:error

echo An error occurred, see the makeall.rpt report file ...

:return

cd ..

@echo on
