Attribute VB_Name = "modGpsTime"

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FILE: gpstime.bas             Copyright Symmetric Research 2003-2004 '
'                                                                      '
' This file contains constants, global variables and general routines  '
' for the Visual Basic PARGPS test program.                            '
'                                                                      '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit



''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                                                      '
'                           CONSTANTS                                  '
'                                                                      '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Public Const DEMO_STOPPED As Long = 0
Public Const DEMO_RUNNING As Long = 1




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                                                      '
'                      GLOBAL VARIABLES                                '
'                                                                      '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Public ParGpsHandle As Long
Public DemoState    As Long
Public TickCount    As Long
Public Year         As Long
Public Month        As Long
Public Day          As Long
Public Hour         As Long
Public Min          As Long
Public Sec          As Long
Public Msec         As Long
Public Nsat         As Long
Public Lat          As Double
Public Lon          As Double
Public Alt          As Double
Public SrcYmd       As Long
Public SrcHms       As Long
Public SrcNsat      As Long
Public SrcPos       As Long
Public LastDay      As Long
Public NL           As String


' Time source string allocation, initialized in ParGpsInitTimeSourceStr() below

Public TIME_SRC_STR(SRCSTR_MIN + 1 To SRCSTR_MAX - 1) As String



''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                                                      '
'                      GLOBAL PROCEDURES                               '
'                                                                      '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

' Initialize the Time source string array

Public Sub ParGpsInitTimeSourceStr()

        TIME_SRC_STR(SRCSTR_ZDA) = "ZDA"
        TIME_SRC_STR(SRCSTR_GGA) = "GGA"
        TIME_SRC_STR(SRCSTR_GLL) = "GLL"
        TIME_SRC_STR(SRCSTR_VTG) = "VTG"
        TIME_SRC_STR(SRCSTR_GSA) = "GSA"
        TIME_SRC_STR(SRCSTR_GSV) = "GSV"
        TIME_SRC_STR(SRCSTR_RMC) = "RMC"
        TIME_SRC_STR(SRCSTR_PC) = "PC "
        TIME_SRC_STR(SRCSTR_OLD) = "OLD"
        TIME_SRC_STR(SRCSTR_UNK) = "   "

End Sub
